#!/usr/bin/python
# -*- coding: utf-8 -*-
#Numerazione progressiva Oggetti = o100

#Programma per realizzare bozze 3D tramite immagini ecc...
print """
Bozze, programma per realizzare bozze in prospettiva e assonometrie tramite immagini.
"""

print
print "Sviluppato in Python da Pietro Cona"
print "Sito: www.strutture-forme-colori-movimenti.net"
print "Sotto licenza GPL (Vedi file allegati)"
print "In collaborazione con Arredamenti Cona S.a.S."
print "(Visita il sito per maggiori dettagli)"
print
print


import Image
import ImageDraw
import Tkinter
import ImageTk
import Graf_equa
import anydbm
import sys
import traceback
import tkColorChooser
import Equazioni
import PosDimTk


def disegna():
    img = dizio["img"]
    y = dizio["y"]
    y = int(yT.get())
    imma = dizio["imma"]
    fines = dizio["fines"]
    immag = dizio["immag"]
    root = dizio["root"]
    for x in range(L):
        try:
            xI,yI = Graf_equa.Carts_Immg(x,y,D,OIx,OIy,A,L)
            img.putpixel((xI,yI),(R,G,B))
        except:
            #Errore
            Errore = 1
    immag = ImageTk.PhotoImage(img)
    imma = fines.create_image(0,0,image=immag,anchor=Tkinter.NW)
    root.mainloop()
    
def ridisegna():
    img = dizio["img"]
    y = dizio["y"]
    y = int(yT.get())
    imma = dizio["imma"]
    fines = dizio["fines"]
    immag = dizio["immag"]
    root = dizio["root"]
    fines.delete(imma)
    img = Image.new('RGB',(L,A),color=(RS,GS,BS))
    for x in range(L):
        try:
            xI,yI = Graf_equa.Carts_Immg(x,y,D,OIx,OIy,A,L)
            img.putpixel((xI,yI),(R,G,B))
        except:
            #Errore
            Errore = 1
    immag = ImageTk.PhotoImage(img)
    imma = fines.create_image(0,0,image=immag,anchor=Tkinter.NW)
    root.mainloop()
    
def cancella():
    #imma = dizio["imma"]
    imma = dizio["idogg"]
    fines = dizio["fines"]
    immag = dizio["immag"]
    root = dizio["root"]
    fines.delete(imma)
    img = Image.new('RGB',(L,A),color=(RS,GS,BS))
    dizio["img"] = img
    immag = ImageTk.PhotoImage(img)
    imma = fines.create_image(0,0,image=immag,anchor=Tkinter.NW)
    root.mainloop()

def termina():
    root=dizio["root"]
    root.destroy()
    sys.exit('Termine del programma')

def colore():
    global dizio
    coloreNuovo=tkColorChooser.askcolor()
    print coloreNuovo
    global COLORE
    COLORE=coloreNuovo[1]
    print COLORE
    dizio["Val_R"].set(coloreNuovo[0][0])
    dizio["Val_G"].set(coloreNuovo[0][1])
    dizio["Val_B"].set(coloreNuovo[0][2])
    root8=Tkinter.Toplevel(root)
    root8.title("Specifica il colore")
    spaz_1 = Tkinter.Frame(root8)
    spaz_1.pack(side = Tkinter.TOP,anchor=Tkinter.CENTER)
    larg_fin = Tkinter.Canvas(spaz_1,width=200,height=0)
    larg_fin.pack()
    Tkinter.Entry(spaz_1,text= "Valore Rosso",textvariable=dizio["Val_R"]).pack(side=Tkinter.TOP)
    Tkinter.Entry(spaz_1,text= "Valore Verde",textvariable=dizio["Val_G"]).pack(side=Tkinter.TOP)
    Tkinter.Entry(spaz_1,text= "Valore Blu",textvariable=dizio["Val_B"]).pack(side=Tkinter.TOP)
    Tkinter.Entry(spaz_1,text= "Valore spessore",textvariable=dizio["Val_spes"]).pack(side=Tkinter.TOP)
    root8.mainloop()
    

def cosa_trac():
    root2=Tkinter.Toplevel(root)
    root2.title("Cosa Tracciare")
    spaz_1 = Tkinter.Frame(root2)
    spaz_1.pack(side = Tkinter.TOP,anchor=Tkinter.CENTER)
    larg_fin = Tkinter.Canvas(spaz_1,width=200,height=0)
    larg_fin.pack()
    Tkinter.Button(spaz_1,text= "Seleziona\noggetto",command=imp_sel_ogg).pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Cancella\noggetto",command=imp_canc_ogg).pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Crea punti di fuga\n della prospettiva",command=imp_p_f_prosp).pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Rette in prospettiva",command=imp_dis_rett_prosp).pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Traccia Prospettiva",command=imp_tra_prosp).pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Posiziona i fuochi\ndella prospettiva",command=imp_fuoc_prosp).pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Traccia assonometria",command=imp_tra_asso).pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Disegno libero",command=imp_dis_libe).pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Retta",command=imp_dis_rett).pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Linea curva\ntra rette",command=imp_dis_curv).pack(side=Tkinter.TOP)
    #Tkinter.Button(spaz_1,text= "Retta 2",command=imp_dis_rett_2).pack(side=Tkinter.TOP)
    #Tkinter.Button(spaz_1,text= "Rettangolo",command=imp_dis_rettan).pack(side=Tkinter.TOP)
    #Tkinter.Button(spaz_1,text= "Poligono irregolare",command=imp_dis_polig_irre).pack(side=Tkinter.TOP)
    #Tkinter.Button(spaz_1,text= "Circonferenza",command=imp_dis_circon).pack(side=Tkinter.TOP)
    #Tkinter.Button(spaz_1,text= "Ellisse",command=imp_dis_ellis).pack(side=Tkinter.TOP)
    #Tkinter.Button(spaz_1,text= "Parabola",command=imp_dis_parabo).pack(side=Tkinter.TOP)
    #Tkinter.Button(spaz_1,text= "Iperbole",command=imp_dis_iperbo).pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Carica immagine \nda disegnare",command=caric_img_da_dis).pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Disegna con immagine",command=imp_dis_c_img).pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Crea immagine",command=crea_immagine).pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Salva immagine",command=salva_immagine).pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Chiudi",command=root2.destroy).pack(side=Tkinter.TOP)
    root2.mainloop()

def imp_sel_ogg():
    dizio["scelta_strum"] = "selez"
def imp_canc_ogg():
    #dizio["scelta_strum"] = "canc_ogg"
    canc_oggett()
def imp_p_f_prosp():
    dizio["scelta_strum"] = "p_f_prosp"
    dizio["car_prem"]="x"
    list_p_r_p_f_x = []
    list_p_r_p_f_y = []
    list_p_r_p_f_z = []
    dizio["imp_p_f_x"]=0
    dizio["imp_p_f_y"]=0
    dizio["imp_p_f_z"]=0
    yT.set("Taccia X")
def imp_dis_rett_prosp():
    dizio["scelta_strum"] = "dis_rett_prosp"
def imp_tra_prosp():
    dizio["scelta_strum"] = "tra_prosp"
    dizio["entra"]=1
def imp_tra_asso():
    dizio["scelta_strum"] = "tra_asso"
def imp_dis_libe():
    dizio["scelta_strum"] = "dis_libe"
def imp_dis_rett():
    dizio["scelta_strum"] = "dis_rett"
def imp_dis_curv():
    global list_segm_curv
    dizio["scelta_strum"] = "dis_curv"
    dizio["dis_curv_pat"] = 1
    list_segm_curv=[]
def imp_dis_rett_2():
    dizio["scelta_strum"] = "dis_rett_2"
def imp_dis_rettan():
    dizio["scelta_strum"] = "dis_rettan"
def imp_dis_polig_irre():
    dizio["scelta_strum"] = "dis_polig_irre"
def imp_dis_circon():
    dizio["scelta_strum"] = "dis_circon"
def imp_dis_ellis():
    dizio["scelta_strum"] = "dis_ellis"
def imp_dis_parabo():
    dizio["scelta_strum"] = "dis_parabo"
def imp_dis_iperbo():
    dizio["scelta_strum"] = "dis_iperbo"
def imp_dis_c_img():
    dizio["scelta_strum"] = "dis_c_img"

def sel_oggett(Evento):
    #fines = dizio["fines"]
    #try:
    #    if(dizio["canc_rip_ogg"]==1):
    #        fines.delete(dizio["idogg"])
    #except:
    #    traceback.print_exc()
    #    nulla=None
    dizio["Pos_Mx"].set(Evento.x)
    dizio["Pos_My"].set(Evento.y)
    prim_x=dizio["Pos_Mx_B1p"]
    prim_y=dizio["Pos_My_B1p"]
    #Val_R_esa = dizio["Val_R"].get()
    #Val_G_esa = dizio["Val_G"].get()
    #Val_B_esa = dizio["Val_B"].get()
    #dizio["idogg"] = Evento.widget.create_line([prim_x,prim_y,dizio["Pos_Mx"].get(),dizio["Pos_My"].get()],fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    dizio["canc_rip_ogg"]=1
    #print Evento.widget.find_withtag ([10,20])
    #print Evento.widget.find_withtag (Tkinter.CURRENT)
    #print Evento.widget.find_closest ( 10, 20, halo=None, start=None )
    dizio["insim_ogg"] = Evento.widget.find_overlapping(prim_x,prim_y,dizio["Pos_Mx"].get(),dizio["Pos_My"].get())
    print dizio["insim_ogg"]

def canc_oggett():
    fines = dizio["fines"]
    try:
        for c in range(len(dizio["insim_ogg"])-1):
            fines.delete(dizio["insim_ogg"][c+1])
    except:
        traceback.print_exc()
        nulla=None
    #dizio["Pos_Mx"].set(Evento.x)
    #dizio["Pos_My"].set(Evento.y)
    #prim_x=dizio["Pos_Mx_B1p"]
    #prim_y=dizio["Pos_My_B1p"]
    #Val_R_esa = dizio["Val_R"].get()
    #Val_G_esa = dizio["Val_G"].get()
    #Val_B_esa = dizio["Val_B"].get()
    #dizio["idogg"] = Evento.widget.create_line([prim_x,prim_y,dizio["Pos_Mx"].get(),dizio["Pos_My"].get()],fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    #dizio["canc_rip_ogg"]=1
    #print Evento.widget.find_withtag ([10,20])
    #print Evento.widget.find_withtag (Tkinter.CURRENT)
    #print Evento.widget.find_closest ( 10, 20, halo=None, start=None )
    #dizio["insim_ogg"] = Evento.widget.find_overlapping(prim_x,prim_y,dizio["Pos_Mx"].get(),dizio["Pos_My"].get())
    #print dizio["insim_ogg"]

def crea_p_f_prosp(Evento):
    #seque_ogg = [[Tipo_ogg,id_Tk,[[x1,y1],[x2,y2]],[R,G,B],[spes]],[circonferenza,id_Tk,.....],....,
    #[dis_liber,id_Tk,[[x1,y1],[x2,y2],[x3,y3],[x4,y4],....],[R,G,B],[spes]],[.....]]
    #global idogg
    fines = dizio["fines"]
    try:
        if(dizio["canc_rip_ogg"]==1):
            #nulla=None
            fines.delete(dizio["idogg"])
    except:
        traceback.print_exc()
        nulla=None
    dizio["Pos_Mx"].set(Evento.x)
    dizio["Pos_My"].set(Evento.y)
    prim_x=dizio["Pos_Mx_B1p"]
    prim_y=dizio["Pos_My_B1p"]
    Val_R_esa = dizio["Val_R"].get()
    Val_G_esa = dizio["Val_G"].get()
    Val_B_esa = dizio["Val_B"].get()
    dizio["idogg"] = Evento.widget.create_line([prim_x,prim_y,dizio["Pos_Mx"].get(),dizio["Pos_My"].get()],fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    #print dizio["idogg"]
    dizio["canc_rip_ogg"]=1
    #seque_ogg.append(["retta",dizio["idogg"],[[dizio["Pos_Mx_B1p"],dizio["Pos_My_B1p"]],[dizio["Pos_Mx"].get(),dizio["Pos_My"].get()]],[dizio["Val_R"].get(),dizio["Val_G"].get(),dizio["Val_B"].get()],dizio["Val_spes"].get()])
    #print seque_ogg
    
def dis_ret_in_prosp(Evento):
    #seque_ogg = [[Tipo_ogg,id_Tk,[[x1,y1],[x2,y2]],[R,G,B],[spes]],[circonferenza,id_Tk,.....],....,
    #[dis_liber,id_Tk,[[x1,y1],[x2,y2],[x3,y3],[x4,y4],....],[R,G,B],[spes]],[.....]]
    #global idogg
    fines = dizio["fines"]
    try:
        if(dizio["canc_rip_ogg"]==1):
            #nulla=None
            fines.delete(dizio["idogg"])
    except:
        traceback.print_exc()
        nulla=None
    dizio["Pos_Mx"].set(Evento.x)
    dizio["Pos_My"].set(Evento.y)
    prim_x=dizio["Pos_Mx_B1p"]
    prim_y=dizio["Pos_My_B1p"]
    Val_R_esa = dizio["Val_R"].get()
    Val_G_esa = dizio["Val_G"].get()
    Val_B_esa = dizio["Val_B"].get()
    dizio["idogg"] = Evento.widget.create_line([prim_x,prim_y,dizio["Pos_Mx"].get(),dizio["Pos_My"].get()],fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    #print dizio["idogg"]
    dizio["canc_rip_ogg"]=1
    #seque_ogg.append(["retta",dizio["idogg"],[[dizio["Pos_Mx_B1p"],dizio["Pos_My_B1p"]],[dizio["Pos_Mx"].get(),dizio["Pos_My"].get()]],[dizio["Val_R"].get(),dizio["Val_G"].get(),dizio["Val_B"].get()],dizio["Val_spes"].get()])
    #print seque_ogg

def trac_prosp(Evento):
    #print "def trac_prosp():"
    #seque_ogg = [[retta,id_Tk,[[x1,y1],[x2,y2]],[R,G,B],[spes]],[circonferenza,id_Tk,.....],....,
    #[dis_liber,id_Tk,[[x1,y1],[x2,y2],[x3,y3],[x4,y4],....],[R,G,B],[spes]],[.....]]
    global idogg
    fines = dizio["fines"]
    try:
        if(dizio["canc_rip_ogg"]==1):
            fines.delete(idogg)
    except:
        traceback.print_exc()
        nulla=None
    #dizio["Pos_Mx"].set(Evento.x)
    #dizio["Pos_My"].set(Evento.y)
    #prim_x=dizio["Pos_Mx_B1p"]
    #prim_y=dizio["Pos_My_B1p"]
    #pos_f_x = 0
    #pos_f_x = 100
    dizio["pos_op_f_x"]=Evento.x
    dizio["pos_op_f_y"]=Evento.y
    dizio["pos_in_f_x"]=dizio["pos_f_x"]
    dizio["pos_in_f_y"]=dizio["pos_f_y"]
    Val_R_esa = dizio["Val_R"].get()
    Val_G_esa = dizio["Val_G"].get()
    Val_B_esa = dizio["Val_B"].get()
    idogg = Evento.widget.create_line([dizio["pos_f_x"],dizio["pos_f_y"],dizio["pos_op_f_x"],dizio["pos_op_f_y"]],fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    dizio["canc_rip_ogg"]=1

def trac_prosp_2(Evento):
    #print "def trac_prosp_2(Evento):"
    global idogg
    fines = dizio["fines"]
    try:
        if(dizio["canc_rip_ogg"]==1):
            fines.delete(idogg)
    except:
        traceback.print_exc()
        nulla=None
    Val_R_esa = dizio["Val_R"].get()
    Val_G_esa = dizio["Val_G"].get()
    Val_B_esa = dizio["Val_B"].get()
    x=Evento.x
    [a,b,c] = Equazioni.equ_retta().retta_p1_p2(dizio["pos_in_f_x"],dizio["pos_in_f_y"],dizio["pos_op_f_x"],dizio["pos_op_f_y"])
    #[a,b,c] = Equazioni.equ_retta().retta_p1_p2(-1,1,-3,3)
    try:
        m=Equazioni.equ_retta().retta_coef_ang_m (a,b)
        #print m
        if(m<= 1 and m>=-1):
            #nulla=None
            y = Equazioni.intersez().p_inter_1_ret_1_ret_v (a,b,c,x)
        else:
            #nulla=None
            y=Evento.y
            x = Equazioni.intersez().p_inter_1_ret_1_ret_o (a,b,c,y)
        dizio["pos_in_f_x"]=x
        dizio["pos_in_f_y"]=y
        idogg = Evento.widget.create_line([x,y,dizio["pos_op_f_x"],dizio["pos_op_f_y"]],fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
        dizio["canc_rip_ogg"]=1
    except:
        try:
            #nulla=None
            y=Evento.y
            x = Equazioni.intersez().p_inter_1_ret_1_ret_o (a,b,c,y)
            dizio["pos_in_f_x"]=x
            dizio["pos_in_f_y"]=y
            idogg = Evento.widget.create_line([x,y,dizio["pos_op_f_x"],dizio["pos_op_f_y"]],fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
            dizio["canc_rip_ogg"]=1
        except:
            #print "Errore"
            #nulla=None
            dizio["scelta_strum"]="tra_prosp"
    #try:
    #    y = Equazioni.intersez().p_inter_1_ret_1_ret_v (a,b,c,x)
    #except:
    #    try:
    #        y=Evento.y
    #        x = Equazioni.intersez().p_inter_1_ret_1_ret_o (a,b,c,y)
    #    except:
    #        nulla=None
    #dizio["pos_in_f_x"]=x
    #dizio["pos_in_f_y"]=y
    #idogg = Evento.widget.create_line([dizio["pos_f_x"],dizio["pos_f_y"],Evento.x,Evento.y],fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    #idogg = Evento.widget.create_line([x,y,dizio["pos_op_f_x"],dizio["pos_op_f_y"]],fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    #dizio["canc_rip_ogg"]=1

def trac_prosp_3(Evento):
    #print "def trac_prosp_3(Evento):"
    global idogg
    fines = dizio["fines"]
    try:
        if(dizio["canc_rip_ogg"]==1):
            fines.delete(idogg)
    except:
        traceback.print_exc()
        nulla=None
    Val_R_esa = dizio["Val_R"].get()
    Val_G_esa = dizio["Val_G"].get()
    Val_B_esa = dizio["Val_B"].get()
    x=Evento.x
    [a,b,c] = Equazioni.equ_retta().retta_p1_p2(dizio["pos_in_f_x"],dizio["pos_in_f_y"],dizio["pos_op_f_x"],dizio["pos_op_f_y"])
    try:
        m=Equazioni.equ_retta().retta_coef_ang_m (a,b)
        #print m
        if(m<= 1 and m>=-1):
            #nulla=None
            y = Equazioni.intersez().p_inter_1_ret_1_ret_v (a,b,c,x)
        else:
            #nulla=None
            y=Evento.y
            x = Equazioni.intersez().p_inter_1_ret_1_ret_o (a,b,c,y)
        dizio["pos_op_f_x"]=x
        dizio["pos_op_f_y"]=y
        idogg = Evento.widget.create_line([dizio["pos_in_f_x"],dizio["pos_in_f_y"],x,y],tags='retta 1',fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
        #print dizio["fines"].gettags('retta 1')
        #print Evento.widget.gettags('retta 1')
        #print Evento.widget.find_withtag (Tkinter.CURRENT)
        dizio["canc_rip_ogg"]=1
    except:
        try:
            #nulla=None
            y=Evento.y
            x = Equazioni.intersez().p_inter_1_ret_1_ret_o (a,b,c,y)
            dizio["pos_op_f_x"]=x
            dizio["pos_op_f_y"]=y
            idogg = Evento.widget.create_line([dizio["pos_in_f_x"],dizio["pos_in_f_y"],x,y],tags='retta 1',fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
            #print dizio["fines"].gettags('retta 1')
            #print Evento.widget.gettags('retta 1')
            dizio["canc_rip_ogg"]=1
        except:
            #print "Errore"
            nulla=None
    #try:
    #    y = Equazioni.intersez().p_inter_1_ret_1_ret_v (a,b,c,x)
    #except:
    #    try:
    #        y=Evento.y
    #        x = Equazioni.intersez().p_inter_1_ret_1_ret_o (a,b,c,y)
    #    except:
    #        nulla=None
    #dizio["pos_op_f_x"]=x
    #dizio["pos_op_f_y"]=y
    #idogg = Evento.widget.create_line([dizio["pos_in_f_x"],dizio["pos_in_f_y"],x,y],fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    #dizio["canc_rip_ogg"]=1

def imp_fuoc_prosp():
    #print "def imp_fuoc_prosp():"
    root8=Tkinter.Toplevel(root)
    root8.title("Imposta i Fuochi")
    spaz_1 = Tkinter.Frame(root8)
    spaz_1.pack(side = Tkinter.TOP,anchor=Tkinter.CENTER)
    larg_fin = Tkinter.Canvas(spaz_1,width=200,height=0)
    larg_fin.pack()
    Tkinter.Entry(spaz_1,text= "Fuoco 1x x",textvariable=dizio["pos_f_x_ass_x"]).pack(side=Tkinter.TOP)
    Tkinter.Entry(spaz_1,text= "Fuoco 1x y",textvariable=dizio["pos_f_y_ass_x"]).pack(side=Tkinter.TOP)
    Tkinter.Entry(spaz_1,text= "Fuoco 2y x",textvariable=dizio["pos_f_x_ass_y"]).pack(side=Tkinter.TOP)
    Tkinter.Entry(spaz_1,text= "Fuoco 2y y",textvariable=dizio["pos_f_y_ass_y"]).pack(side=Tkinter.TOP)
    Tkinter.Entry(spaz_1,text= "Fuoco 3z x",textvariable=dizio["pos_f_x_ass_z"]).pack(side=Tkinter.TOP)
    Tkinter.Entry(spaz_1,text= "Fuoco 3z y",textvariable=dizio["pos_f_y_ass_z"]).pack(side=Tkinter.TOP)
    root8.mainloop()

def trac_asson(Evento):
    #print "def trac_asson():"
    #seque_ogg = [[retta,id_Tk,[[x1,y1],[x2,y2]],[R,G,B],[spes]],[circonferenza,id_Tk,.....],....,
    #[dis_liber,id_Tk,[[x1,y1],[x2,y2],[x3,y3],[x4,y4],....],[R,G,B],[spes]],[.....]]
    global idogg
    fines = dizio["fines"]
    try:
        if(dizio["canc_rip_ogg"]==1):
            fines.delete(idogg)
    except:
        traceback.print_exc()
        nulla=None
    dizio["Pos_Mx"].set(Evento.x)
    dizio["Pos_My"].set(Evento.y)
    prim_x=dizio["Pos_Mx_B1p"]
    prim_y=dizio["Pos_My_B1p"]
    Val_R_esa = dizio["Val_R"].get()
    Val_G_esa = dizio["Val_G"].get()
    Val_B_esa = dizio["Val_B"].get()
    idogg = Evento.widget.create_line([prim_x,prim_y,Evento.x,Evento.y],fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    dizio["canc_rip_ogg"]=1

def dis_libero(Evento):
    #seque_ogg = [[retta,id_Tk,[[x1,y1],[x2,y2]],[R,G,B],[spes]],[circonferenza,id_Tk,.....],....,
    #[dis_liber,id_Tk,[[x1,y1],[x2,y2],[x3,y3],[x4,y4],....],[R,G,B],[spes]],[.....]]
    #print "def dis_libero():"
    global lista_cord
    dizio["Pos_Mx"].set(Evento.x)
    dizio["Pos_My"].set(Evento.y)
    #img = dizio["img"]
    #y = dizio["y"]
    #y = int(yT.get())
    #imma = dizio["imma"]
    #fines = dizio["fines"]
    #immag = dizio["immag"]
    #root = dizio["root"]
    #fines.delete(imma)
    #img = Image.new('RGB',(L,A),color=(RS,GS,BS))
    #img.putpixel((Evento.x,Evento.y),(0,0,0))
    #immag = ImageTk.PhotoImage(img)
    #imma = fines.create_image(0,0,image=immag,anchor=Tkinter.NW)
    #Evento.widget.create_image(0,0,image=immag)
    try:
        #print "Numero di occorenze %s" %(len(lista_cord))
        if(len(lista_cord)>=4):
            #print "punto 1"
            ult_x = lista_cord[-2]
            ult_y = lista_cord[-1]
            lista_cord=[]
            lista_cord.append(ult_x)
            lista_cord.append(ult_y)
    except:
        nulla=None
        traceback.print_exc()
    lista_cord.append(Evento.x)
    lista_cord.append(Evento.y)
    try:
        #Val_R_esa = hex(dizio["Val_R"].get())[2:]
        #Val_G_esa = hex(dizio["Val_G"].get())[2:]
        #Val_B_esa = hex(dizio["Val_B"].get())[2:]
        Val_R_esa = dizio["Val_R"].get()
        Val_G_esa = dizio["Val_G"].get()
        Val_B_esa = dizio["Val_B"].get()
        #print dizio["Val_R"].get()
        #print Val_R_esa
        #print dizio["Val_G"].get()
        #print Val_G_esa
        #print dizio["Val_B"].get()
        #print Val_B_esa
        #print "%02X"%dizio["Val_R"].get()
        Evento.widget.create_line(lista_cord,smooth=1,fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    except:
        #traceback.print_exc()
        nulla=None
    #print lista_cord
    #root.mainloop()

def caric_img_da_dis():
    print "caric_img_da_dis():"
    dizio["img_dis"] = Image.open("Arpa 4396 Speciale Fin Pesca 2.jpg")

def spaz_dis_c_immag(Evento):
    #seque_ogg = [[retta,id_Tk,[[x1,y1],[x2,y2]],[R,G,B],[spes]],[circonferenza,id_Tk,.....],....,
    #[dis_liber,id_Tk,[[x1,y1],[x2,y2],[x3,y3],[x4,y4],....],[R,G,B],[spes]],[.....]]
    global lista_cord_img,lista_cord_img_f
    dizio["Pos_Mx"].set(Evento.x)
    dizio["Pos_My"].set(Evento.y)
    lista_cord_img_f.append([Evento.x,Evento.y])
    try:
        #print len(lista_cord_img)
        if(len(lista_cord_img)>=2):
            ult_x_y = lista_cord_img[-1]
            #ult_x = lista_cord_img[-2]
            #ult_y = lista_cord_img[-1]
            del lista_cord_img
            lista_cord_img=[]
            lista_cord_img.append([ult_x_y[0],ult_x_y[1]])
            #lista_cord_img.append(ult_y)
    except:
        nulla=None
        traceback.print_exc()
    lista_cord_img.append([Evento.x,Evento.y])
    #lista_cord_img.append(Evento.y)
    try:
        Val_R_esa = dizio["Val_R"].get()
        Val_G_esa = dizio["Val_G"].get()
        Val_B_esa = dizio["Val_B"].get()
        Evento.widget.create_line(lista_cord_img,fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    except:
        nulla=None
    #print lista_cord_img
        
def dis_c_immag():
    #print "def dis_c_immag():"
    global lista_cord_img_f
    root = dizio["root"]
    fines = dizio["fines"]
    img = dizio["img"]
    #img.convert('RGBA')
    #imma = dizio["imma"]
    #fines.delete(imma)
    #print lista_cord_img_f
    for c in range(len(lista_cord_img_f)):
        #print lista_cord_img_f[c]
        #print lista_cord_img_f[c][1]
        pos_m_x=lista_cord_img_f[c][0]
        pos_m_y=lista_cord_img_f[c][1]
        pos_m_y_ = pos_m_y
        try:
            for y in range(20):
                pos_m_x_ = pos_m_x
                for x in range(20):
                    color=dizio["img_dis"].getpixel((pos_m_x,pos_m_y))
                    img.putpixel((pos_m_x,pos_m_y),(color[0],color[1],color[2]))
                    pos_m_x_ += 1
                pos_m_y_ += 1
        except:
            traceback.print_exc()
            nulla=None
        #print color
        print dir(ImageTk)
        print
        print dir(ImageTk.getimage)
        print
        print dir(fines)
        print
        print dir(root)
        immag = ImageTk.PhotoImage(img)
        #immag = ImageTk.getimage()
        #immag = ImageTk.BitmapImage(img)
        #immag = ImageTk.Image()
        imma = fines.create_image(0,0,image=immag,anchor=Tkinter.NW)
        #imma = fines.create_bitmap(0,0,image=immag,anchor=Tkinter.NW)
        print imma
        fines.update_idletasks()
        lista_cord_img_f=[]
        root.mainloop()

def crea_immagine():
    print "def crea_immagine():"
    #seque_ogg = [[retta,id_Tk,[[x1,y1],[x2,y2]],[R,G,B],[spes]],[circonferenza,id_Tk,.....],....,
    #[dis_liber,id_Tk,[[x1,y1],[x2,y2],[x3,y3],[x4,y4],....],[R,G,B],[spes]],[.....]]
    

def salva_immagine():
    img = dizio["img"]
    img.save('Prova_salvataggio.jpg')
    

def dis_retta(Evento):
    #seque_ogg = [[Tipo_ogg,id_Tk,[[x1,y1],[x2,y2]],[R,G,B],[spes]],[circonferenza,id_Tk,.....],....,
    #[dis_liber,id_Tk,[[x1,y1],[x2,y2],[x3,y3],[x4,y4],....],[R,G,B],[spes]],[.....]]
    #global idogg
    fines = dizio["fines"]
    try:
        if(dizio["canc_rip_ogg"]==1):
            #nulla=None
            fines.delete(dizio["idogg"])
    except:
        traceback.print_exc()
        nulla=None
    dizio["Pos_Mx"].set(Evento.x)
    dizio["Pos_My"].set(Evento.y)
    prim_x=dizio["Pos_Mx_B1p"]
    prim_y=dizio["Pos_My_B1p"]
    Val_R_esa = dizio["Val_R"].get()
    Val_G_esa = dizio["Val_G"].get()
    Val_B_esa = dizio["Val_B"].get()
    dizio["idogg"] = Evento.widget.create_line([prim_x,prim_y,dizio["Pos_Mx"].get(),dizio["Pos_My"].get()],fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    #print dizio["idogg"]
    dizio["canc_rip_ogg"]=1
    #seque_ogg.append(["retta",dizio["idogg"],[[dizio["Pos_Mx_B1p"],dizio["Pos_My_B1p"]],[dizio["Pos_Mx"].get(),dizio["Pos_My"].get()]],[dizio["Val_R"].get(),dizio["Val_G"].get(),dizio["Val_B"].get()],dizio["Val_spes"].get()])
    #print seque_ogg

def dis_lin_curv(Evento):
    #seque_ogg = [[Tipo_ogg,id_Tk,[[x1,y1],[x2,y2]],[R,G,B],[spes]],[circonferenza,id_Tk,.....],....,
    #[dis_liber,id_Tk,[[x1,y1],[x2,y2],[x3,y3],[x4,y4],....],[R,G,B],[spes]],[.....]]
    #global idogg
    fines = dizio["fines"]
    try:
        if(dizio["canc_rip_ogg"]==1):
            #nulla=None
            fines.delete(dizio["id_seg_curv"])
            fines.delete(dizio["id_curv"])
    except:
        traceback.print_exc()
        nulla=None
    dizio["Pos_Mx"].set(Evento.x)
    dizio["Pos_My"].set(Evento.y)
    #prim_x=dizio["Pos_Mx_B1p"]
    #prim_y=dizio["Pos_My_B1p"]
    Val_R_esa = dizio["Val_R"].get()
    Val_G_esa = dizio["Val_G"].get()
    Val_B_esa = dizio["Val_B"].get()
    #dizio["idogg"] = Evento.widget.create_line([dizio["Pos_Mx_B1p"],dizio["Pos_My_B1p"],dizio["Pos_Mx"].get(),dizio["Pos_My"].get()],smooth=0,fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    #dizio["idogg"] = Evento.widget.create_line([dizio["Pos_Mx_B1p"],dizio["Pos_My_B1p"],dizio["Pos_Mx"].get(),dizio["Pos_My"].get()],smooth=1,fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    dizio["id_seg_curv"] = Evento.widget.create_line([list_segm_curv,dizio["Pos_Mx"].get(),dizio["Pos_My"].get()],smooth=0,fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    dizio["id_curv"] = Evento.widget.create_line([list_segm_curv,dizio["Pos_Mx"].get(),dizio["Pos_My"].get()],smooth=1,fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    #dizio["idogg"] = Evento.widget.create_line([10,100,300,200,700,500],smooth=0,fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    #dizio["idogg"] = Evento.widget.create_line([10,100,300,200,700,500],smooth=1,fill="#%02X%02X%02X"%(Val_R_esa,Val_G_esa,Val_B_esa),width=dizio["Val_spes"].get())
    #print dizio["idogg"]
    dizio["canc_rip_ogg"]=1
    #seque_ogg.append(["retta",dizio["idogg"],[[dizio["Pos_Mx_B1p"],dizio["Pos_My_B1p"]],[dizio["Pos_Mx"].get(),dizio["Pos_My"].get()]],[dizio["Val_R"].get(),dizio["Val_G"].get(),dizio["Val_B"].get()],dizio["Val_spes"].get()])
    #print seque_ogg

def dis_retta_2(Evento):
    #print "def dis_retta_2(Evento):"
    #dizio["img"] = Image.new('RGB',(L,A),color=(RS,GS,BS))
    #dizio["img_var"] = Image.new('RGB',(10,10),color=(255,255,255))
    #dizio["immag"] = ImageTk.PhotoImage(dizio["img"])
    #dizio["fines"].delete(dizio["idogg"])
    #dizio["img_var"]=dizio["img"]
    try:
        if(dizio["canc_rip_ogg"]==1):
            dizio["fines"].delete(dizio["idogg"])
            dizio["img"] = Image.new('RGB',(L,A),color=(RS,GS,BS))
    except:
        traceback.print_exc()
        nulla=None
    dizio["Pos_Mx"].set(Evento.x)
    dizio["Pos_My"].set(Evento.y)
    prim_x=dizio["Pos_Mx_B1p"]
    prim_y=dizio["Pos_My_B1p"]
    Val_R = dizio["Val_R"].get()
    Val_G = dizio["Val_G"].get()
    Val_B = dizio["Val_B"].get()
    disegna = ImageDraw.Draw(dizio["img"])
    #disegna.line((lista_punti),fill=128,width=10)
    disegna.line([prim_x,prim_y,Evento.x,Evento.y],fill="#%02X%02X%02X"%(Val_R,Val_G,Val_B),width=dizio["Val_spes"].get())
    dizio["immag"] = ImageTk.PhotoImage(dizio["img"])
    #dizio["idogg"] = Evento.widget.create_image(0,0,image=dizio["immag"],anchor=Tkinter.NW)
    dizio["idogg"] = dizio["fines"].create_image(0,0,image=dizio["immag"],anchor=Tkinter.NW)
    dizio["canc_rip_ogg"]=1
    #immag = ImageTk.PhotoImage(img)
    #fines.update_idletasks()
    dizio["fines"].update()
    dizio["root"].mainloop()

def retta():
    root3=Tkinter.Toplevel(root)
    root3.title("Retta")
    spaz_1 = Tkinter.Frame(root3)
    larg_fin = Tkinter.Canvas(spaz_1,width=200,height=0)
    larg_fin.pack()
    Tkinter.Label(spaz_1,text= "Retta passante per i punti:").pack(side=Tkinter.TOP)
    spaz_1.pack()
    spaz_2 = Tkinter.Frame(root3)
    xP1=1
    yP1=2
    xP2=3
    yP2=4
    xP1T=Tkinter.StringVar()
    yP1T=Tkinter.StringVar()
    xP2T=Tkinter.StringVar()
    yP2T=Tkinter.StringVar()
    xP1T.set(xP1)
    yP1T.set(yP1)
    xP2T.set(xP2)
    yP2T.set(yP2)
    Tkinter.Label(spaz_2,text= "P1").pack(side=Tkinter.LEFT)
    Tkinter.Entry(spaz_2,textvariable=xP1T).pack(side=Tkinter.LEFT)
    Tkinter.Label(spaz_2,text= "x").pack(side=Tkinter.LEFT)
    Tkinter.Entry(spaz_2,textvariable=yP1T).pack(side=Tkinter.LEFT)
    Tkinter.Label(spaz_2,text= "y").pack(side=Tkinter.LEFT)
    Tkinter.Label(spaz_2,text= "P2").pack(side=Tkinter.LEFT)
    Tkinter.Entry(spaz_2,textvariable=xP2T).pack(side=Tkinter.LEFT)
    Tkinter.Label(spaz_2,text= "x").pack(side=Tkinter.LEFT)
    Tkinter.Entry(spaz_2,textvariable=yP2T).pack(side=Tkinter.LEFT)
    Tkinter.Label(spaz_2,text= "y").pack(side=Tkinter.LEFT)
    spaz_2.pack()
    spaz_3 = Tkinter.Frame(root3)
    Tkinter.Button(spaz_3,text= "Chiudi",command=root3.destroy).pack(side=Tkinter.TOP)
    spaz_3.pack()
    root3.mainloop()

def circon():
    root4=Tkinter.Toplevel(root)
    root4.title("Circonferenza")
    spaz_1 = Tkinter.Frame(root4)
    spaz_1.pack(side = Tkinter.TOP,anchor=Tkinter.CENTER)
    larg_fin = Tkinter.Canvas(spaz_1,width=200,height=0)
    larg_fin.pack()
    Tkinter.Label(spaz_1,text= "Circonferenza").pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Chiudi",command=root4.destroy).pack(side=Tkinter.TOP)
    root4.mainloop()

def ellis():
    root5=Tkinter.Toplevel(root)
    root5.title("Ellisse")
    spaz_1 = Tkinter.Frame(root5)
    spaz_1.pack(side = Tkinter.TOP,anchor=Tkinter.CENTER)
    larg_fin = Tkinter.Canvas(spaz_1,width=200,height=0)
    larg_fin.pack()
    Tkinter.Label(spaz_1,text= "Ellisse").pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Chiudi",command=root5.destroy).pack(side=Tkinter.TOP)
    root5.mainloop()

def parab():
    root6=Tkinter.Toplevel(root)
    root6.title("Parabola")
    spaz_1 = Tkinter.Frame(root6)
    spaz_1.pack(side = Tkinter.TOP,anchor=Tkinter.CENTER)
    larg_fin = Tkinter.Canvas(spaz_1,width=200,height=0)
    larg_fin.pack()
    Tkinter.Label(spaz_1,text= "Parabola").pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Chiudi",command=root6.destroy).pack(side=Tkinter.TOP)
    root6.mainloop()

def iperb():
    root7=Tkinter.Toplevel(root)
    root7.title("Iperbole")
    spaz_1 = Tkinter.Frame(root7)
    spaz_1.pack(side = Tkinter.TOP,anchor=Tkinter.CENTER)
    larg_fin = Tkinter.Canvas(spaz_1,width=200,height=0)
    larg_fin.pack()
    Tkinter.Label(spaz_1,text= "Iperbole").pack(side=Tkinter.TOP)
    Tkinter.Button(spaz_1,text= "Chiudi",command=root7.destroy).pack(side=Tkinter.TOP)
    root7.mainloop()

def pos_mouse(Evento):
    #print dizio["fines"].focus_get()
    dizio["Pos_Mx"].set(Evento.x)
    dizio["Pos_My"].set(Evento.y)

def mouse_B1p(Evento):
    if (dizio["scelta_strum"] == "selez"):
        dizio["Pos_Mx_B1p"]=Evento.x
        dizio["Pos_My_B1p"]=Evento.y
        dizio["canc_rip_ogg"]=0
    if (dizio["scelta_strum"]=="p_f_prosp"):
        dizio["Pos_Mx_B1p"]=Evento.x
        dizio["Pos_My_B1p"]=Evento.y
        dizio["canc_rip_ogg"]=0
    if (dizio["scelta_strum"]=="dis_rett_prosp"):
        dizio["Pos_Mx_B1p"]=Evento.x
        dizio["Pos_My_B1p"]=Evento.y
        dizio["canc_rip_ogg"]=0
    if (dizio["scelta_strum"]=="tra_prosp"):
        #dizio["canc_rip_ogg"]=0
        nulla=None
    if (dizio["scelta_strum"]=="tra_prosp_2"):
        #dizio["canc_rip_ogg"]=0
        nulla=None
    if (dizio["scelta_strum"]=="tra_prosp_3"):
        #dizio["canc_rip_ogg"]=0
        nulla=None
    if (dizio["scelta_strum"]=="dis_libe"):
        nulla=None
    if (dizio["scelta_strum"]=="dis_rett"):
        dizio["Pos_Mx_B1p"]=Evento.x
        dizio["Pos_My_B1p"]=Evento.y
        dizio["canc_rip_ogg"]=0
    if (dizio["scelta_strum"]=="dis_curv"):
        #list_segm_curv = []   
        #dizio["Pos_Mx"].set(Evento.x)
        #dizio["Pos_My"].set(Evento.y)
        #print dizio["dis_curv_pat"]
        if (dizio["dis_curv_pat"] == 0):
            dizio["canc_rip_ogg"]=1
        if (dizio["dis_curv_pat"] == 1):
            #print dizio["dis_curv_pat"]
            list_segm_curv.append(dizio["Pos_Mx"].get())
            list_segm_curv.append(dizio["Pos_My"].get())
            #print list_segm_curv
            dizio["dis_curv_pat"] = 0
            dizio["canc_rip_ogg"]=0
        #dizio["Pos_Mx_B1p"]=Evento.x
        #dizio["Pos_My_B1p"]=Evento.y
    if(dizio["scelta_strum"] == "dis_rett_2"):
        dizio["Pos_Mx_B1p"]=Evento.x
        dizio["Pos_My_B1p"]=Evento.y
        dizio["canc_rip_ogg"]=0
    if (dizio["scelta_strum"]=="dis_c_img"):
        nulla=None

def pos_mouse_B1p(Evento):
    if (dizio["scelta_strum"] == "selez"):
        sel_oggett(Evento)
    if (dizio["scelta_strum"]=="p_f_prosp"):
        crea_p_f_prosp(Evento)
    if (dizio["scelta_strum"]=="dis_rett_prosp"):
        dis_ret_in_prosp(Evento)
    if (dizio["scelta_strum"]=="tra_prosp"):
        trac_prosp(Evento)
    if (dizio["scelta_strum"]=="tra_prosp_2"):
        trac_prosp_2(Evento)
    if (dizio["scelta_strum"]=="tra_prosp_3"):
        trac_prosp_3(Evento)
    if (dizio["scelta_strum"]=="dis_libe"):
        dis_libero(Evento)
    if (dizio["scelta_strum"]=="dis_rett"):
        dis_retta(Evento)
    if (dizio["scelta_strum"]=="dis_curv"):
        dis_lin_curv(Evento)
    if(dizio["scelta_strum"] == "dis_rett_2"):
        dis_retta_2(Evento)
    if (dizio["scelta_strum"]=="dis_c_img"):
        spaz_dis_c_immag(Evento)
    #trac_prosp(Evento)
    #trac_asson(Evento)

def mouse_B1r(Evento):
    if (dizio["scelta_strum"] == "selez"):
        dizio["canc_rip_ogg"]=0
    if (dizio["scelta_strum"]=="p_f_prosp"):
        global list_p_r_p_f_x,list_p_r_p_f_y,list_p_r_p_f_z
        #print list_p_r_p_f_x
        #print list_p_r_p_f_y
        #print list_p_r_p_f_z
        dizio["canc_rip_ogg"]=0
        if (dizio["car_prem"]=="x" and dizio["imp_p_f_x"]==0):
            x1=dizio["Pos_Mx_B1p"]
            y1=dizio["Pos_My_B1p"]
            x2=dizio["Pos_Mx"].get()
            y2=dizio["Pos_My"].get()
            seque_ogg.append(["retta prosp x",dizio["idogg"],[[x1,y1],[x2,y2]],\
                              [dizio["Val_R"].get(),dizio["Val_G"].get(),dizio["Val_B"].get()],dizio["Val_spes"].get()])
            [a,b,c] = Equazioni.equ_retta().retta_p1_p2(x1,y1,x2,y2)
            if (len(list_p_r_p_f_x) < 2):
                print "Traccia per punto di fuga X"
                list_p_r_p_f_x.append([a,b,c])
            if (len(list_p_r_p_f_x) == 2):
                a=list_p_r_p_f_x[0][0]
                b=list_p_r_p_f_x[0][1]
                c=list_p_r_p_f_x[0][2]
                d=list_p_r_p_f_x[1][0]
                e=list_p_r_p_f_x[1][1]
                f=list_p_r_p_f_x[1][2]
                x,y = Equazioni.intersez().p_inter_2_ret(a,b,c,d,e,f)
                dizio["pos_f_x_ass_x"].set(x)
                dizio["pos_f_y_ass_x"].set(y)
                #print list_p_r_p_f_x
                #print dizio["pos_f_x_ass_x"].get()
                #print dizio["pos_f_y_ass_x"].get()
                dizio["pos_f_x"]=dizio["pos_f_x_ass_x"].get()
                dizio["pos_f_y"]=dizio["pos_f_y_ass_x"].get()
                list_p_r_p_f_x = []
                dizio["imp_p_f_x"]=1
        if (dizio["car_prem"]=="y" and dizio["imp_p_f_y"]==0):
            x1=dizio["Pos_Mx_B1p"]
            y1=dizio["Pos_My_B1p"]
            x2=dizio["Pos_Mx"].get()
            y2=dizio["Pos_My"].get()
            seque_ogg.append(["retta prosp y",dizio["idogg"],[[x1,y1],[x2,y2]],\
                              [dizio["Val_R"].get(),dizio["Val_G"].get(),dizio["Val_B"].get()],dizio["Val_spes"].get()])
            [a,b,c] = Equazioni.equ_retta().retta_p1_p2(x1,y1,x2,y2)
            if (len(list_p_r_p_f_y) < 2):
                print "Traccia per punto di fuga Y"
                list_p_r_p_f_y.append([a,b,c])
            if (len(list_p_r_p_f_y) == 2):
                a=list_p_r_p_f_y[0][0]
                b=list_p_r_p_f_y[0][1]
                c=list_p_r_p_f_y[0][2]
                d=list_p_r_p_f_y[1][0]
                e=list_p_r_p_f_y[1][1]
                f=list_p_r_p_f_y[1][2]
                x,y = Equazioni.intersez().p_inter_2_ret(a,b,c,d,e,f)
                dizio["pos_f_x_ass_y"].set(x)
                dizio["pos_f_y_ass_y"].set(y)
                #print list_p_r_p_f_y
                #print dizio["pos_f_x_ass_y"].get()
                #print dizio["pos_f_y_ass_y"].get()
                dizio["pos_f_x"]=dizio["pos_f_x_ass_y"].get()
                dizio["pos_f_y"]=dizio["pos_f_y_ass_y"].get()
                list_p_r_p_f_y = []
                dizio["imp_p_f_y"]=1
        if (dizio["car_prem"]=="z" and dizio["imp_p_f_z"]==0):
            x1=dizio["Pos_Mx_B1p"]
            y1=dizio["Pos_My_B1p"]
            x2=dizio["Pos_Mx"].get()
            y2=dizio["Pos_My"].get()
            seque_ogg.append(["retta prosp z",dizio["idogg"],[[x1,y1],[x2,y2]],\
                              [dizio["Val_R"].get(),dizio["Val_G"].get(),dizio["Val_B"].get()],dizio["Val_spes"].get()])
            [a,b,c] = Equazioni.equ_retta().retta_p1_p2(x1,y1,x2,y2)
            if (len(list_p_r_p_f_z) < 2):
                print "Traccia per punto di fuga Z"
                list_p_r_p_f_z.append([a,b,c])
            if (len(list_p_r_p_f_z) == 2):
                a=list_p_r_p_f_z[0][0]
                b=list_p_r_p_f_z[0][1]
                c=list_p_r_p_f_z[0][2]
                d=list_p_r_p_f_z[1][0]
                e=list_p_r_p_f_z[1][1]
                f=list_p_r_p_f_z[1][2]
                x,y = Equazioni.intersez().p_inter_2_ret(a,b,c,d,e,f)
                dizio["pos_f_x_ass_z"].set(x)
                dizio["pos_f_y_ass_z"].set(y)
                #print list_p_r_p_f_z
                #print dizio["pos_f_x_ass_z"].get()
                #print dizio["pos_f_y_ass_z"].get()
                dizio["pos_f_x"]=dizio["pos_f_x_ass_z"].get()
                dizio["pos_f_y"]=dizio["pos_f_y_ass_z"].get()
                list_p_r_p_f_z = []
                dizio["imp_p_f_z"]=1
        if (dizio["imp_p_f_x"]==1 and dizio["imp_p_f_y"]==1 and dizio["imp_p_f_z"]==1):
            print
            imp_tra_prosp()
    if (dizio["scelta_strum"]=="dis_rett_prosp"):
        dizio["canc_rip_ogg"]=0
    if (dizio["scelta_strum"]=="tra_prosp_3"):
        dizio["scelta_strum"]="tra_prosp"
        dizio["canc_rip_ogg"]=0
        dizio["entra"]=0
        #seque_ogg.append(["retta prosp x",dizio["idogg"],[[x1,y1],[x2,y2]],\
        #                  [dizio["Val_R"].get(),dizio["Val_G"].get(),dizio["Val_B"].get()],dizio["Val_spes"].get()])
        #seque_ogg.append(["retta prosp y",dizio["idogg"],[[x1,y1],[x2,y2]],\
        #                  [dizio["Val_R"].get(),dizio["Val_G"].get(),dizio["Val_B"].get()],dizio["Val_spes"].get()])
        #seque_ogg.append(["retta prosp z",dizio["idogg"],[[x1,y1],[x2,y2]],\
        #                  [dizio["Val_R"].get(),dizio["Val_G"].get(),dizio["Val_B"].get()],dizio["Val_spes"].get()])
    if (dizio["scelta_strum"]=="tra_prosp_2"):
        dizio["scelta_strum"]="tra_prosp_3"
        #dizio["canc_rip_ogg"]=0
    if (dizio["scelta_strum"]=="tra_prosp" and dizio["entra"]==1):
        dizio["scelta_strum"]="tra_prosp_2"
        #dizio["canc_rip_ogg"]=0
    if (dizio["scelta_strum"]=="dis_libe"):
        global lista_cord
        lista_cord=[]
    if (dizio["scelta_strum"]=="dis_rett"):
        dizio["canc_rip_ogg"]=0
        seque_ogg.append(["retta",dizio["idogg"],[[dizio["Pos_Mx_B1p"],dizio["Pos_My_B1p"]],[dizio["Pos_Mx"].get(),dizio["Pos_My"].get()]],[dizio["Val_R"].get(),dizio["Val_G"].get(),dizio["Val_B"].get()],dizio["Val_spes"].get()])
        #print seque_ogg
    if (dizio["scelta_strum"]=="dis_curv"):
        list_segm_curv.append(dizio["Pos_Mx"].get())
        list_segm_curv.append(dizio["Pos_My"].get())
        dizio["canc_rip_ogg"]=0
        dizio["fines"].delete(dizio["id_seg_curv"])
        #seque_ogg.append(["retta",dizio["idogg"],[[dizio["Pos_Mx_B1p"],dizio["Pos_My_B1p"]],[dizio["Pos_Mx"].get(),dizio["Pos_My"].get()]],[dizio["Val_R"].get(),dizio["Val_G"].get(),dizio["Val_B"].get()],dizio["Val_spes"].get()])
        #print seque_ogg
    if(dizio["scelta_strum"] == "dis_rett_2"):
        dizio["canc_rip_ogg"]=0
        #dizio["img"]=dizio["img_var"]
    if (dizio["scelta_strum"]=="dis_c_img"):
        global lista_cord_img
        lista_cord_img=[]
        dis_c_immag()
    dizio["entra"]=1

def prem_car_x(Evento):
    #print "def prem_car_x(Evento):"
    if (dizio["scelta_strum"]=="tra_prosp"):
        yT.set("Taccia X")
        #print "def prem_car_x(Evento): 2"
        dizio["pos_f_x"]=dizio["pos_f_x_ass_x"].get()
        dizio["pos_f_y"]=dizio["pos_f_y_ass_x"].get()
    if (dizio["scelta_strum"]=="tra_prosp_2"):
        dizio["pos_f_x"]=dizio["pos_f_x_ass_x"].get()
        dizio["pos_f_y"]=dizio["pos_f_y_ass_x"].get()
        yT.set("Taccia X")
    if (dizio["scelta_strum"]=="tra_prosp_3"):
        dizio["pos_f_x"]=dizio["pos_f_x_ass_x"].get()
        dizio["pos_f_y"]=dizio["pos_f_y_ass_x"].get()
        yT.set("Taccia X")
    if (dizio["scelta_strum"]=="p_f_prosp"):
        dizio["pos_f_x"]=dizio["pos_f_x_ass_x"].get()
        dizio["pos_f_y"]=dizio["pos_f_y_ass_x"].get()
        yT.set("Taccia X")
        dizio["car_prem"]="x"
        #dizio["pos_f_x_ass_x"].set()
        #dizio["pos_f_y_ass_x"].set()
        nulla=None
    if (dizio["scelta_strum"]=="dis_rett_prosp"):
        dizio["pos_f_x"]=dizio["pos_f_x_ass_x"].get()
        dizio["pos_f_y"]=dizio["pos_f_y_ass_x"].get()
        yT.set("Taccia X")
        nulla=None

def prem_car_y(Evento):
    #print "def prem_car_y(Evento):"
    if (dizio["scelta_strum"]=="tra_prosp"):
        yT.set("Taccia Y")
        #print "def prem_car_y(Evento): 2"
        dizio["pos_f_x"]=dizio["pos_f_x_ass_y"].get()
        dizio["pos_f_y"]=dizio["pos_f_y_ass_y"].get()
    if (dizio["scelta_strum"]=="tra_prosp_2"):
        dizio["pos_f_x"]=dizio["pos_f_x_ass_y"].get()
        dizio["pos_f_y"]=dizio["pos_f_y_ass_y"].get()
        yT.set("Taccia Y")
    if (dizio["scelta_strum"]=="tra_prosp_3"):
        dizio["pos_f_x"]=dizio["pos_f_x_ass_y"].get()
        dizio["pos_f_y"]=dizio["pos_f_y_ass_y"].get()
        yT.set("Taccia Y")
    if (dizio["scelta_strum"]=="p_f_prosp"):
        dizio["pos_f_x"]=dizio["pos_f_x_ass_y"].get()
        dizio["pos_f_y"]=dizio["pos_f_y_ass_y"].get()
        yT.set("Taccia Y")
        dizio["car_prem"]="y"
        nulla=None
    if (dizio["scelta_strum"]=="dis_rett_prosp"):
        dizio["pos_f_x"]=dizio["pos_f_x_ass_y"].get()
        dizio["pos_f_y"]=dizio["pos_f_y_ass_y"].get()
        yT.set("Taccia Y")
        nulla=None

def prem_car_z(Evento):
    #print "def prem_car_z(Evento):"
    if (dizio["scelta_strum"]=="tra_prosp"):
        yT.set("Taccia Z")
        #print "def prem_car_z(Evento): 2"
        dizio["pos_f_x"]=dizio["pos_f_x_ass_z"].get()
        dizio["pos_f_y"]=dizio["pos_f_y_ass_z"].get()
    if (dizio["scelta_strum"]=="tra_prosp_2"):
        dizio["pos_f_x"]=dizio["pos_f_x_ass_z"].get()
        dizio["pos_f_y"]=dizio["pos_f_y_ass_z"].get()
        yT.set("Taccia Z")
    if (dizio["scelta_strum"]=="tra_prosp_3"):
        dizio["pos_f_x"]=dizio["pos_f_x_ass_z"].get()
        dizio["pos_f_y"]=dizio["pos_f_y_ass_z"].get()
        yT.set("Taccia Z")
    if (dizio["scelta_strum"]=="p_f_prosp"):
        dizio["pos_f_x"]=dizio["pos_f_x_ass_z"].get()
        dizio["pos_f_y"]=dizio["pos_f_y_ass_z"].get()
        yT.set("Taccia Z")
        dizio["car_prem"]="z"
        nulla=None
    if (dizio["scelta_strum"]=="dis_rett_prosp"):
        dizio["pos_f_x"]=dizio["pos_f_x_ass_z"].get()
        dizio["pos_f_y"]=dizio["pos_f_y_ass_z"].get()
        yT.set("Taccia Z")
        nulla=None

    
dizio={}
seque_ogg = []
#seque_ogg = [[retta,id_Tk,[[x1,y1],[x2,y2]],[R,G,B],[spes]],[circonferenza,id_Tk,.....],....,
#[dis_liber,id_Tk,[[x1,y1],[x2,y2],[x3,y3],[x4,y4],....],[R,G,B],[spes]],[.....]]
lista_cord=[]
lista_cord_img=[]
lista_cord_img_f = []
list_segm_curv = []
dizio["car_prem"]="x"
list_p_r_p_f_x = []
list_p_r_p_f_y = []
list_p_r_p_f_z = []
dizio["pos_in_f_x"]=0
dizio["pos_in_f_y"]=0
dizio["pos_op_f_x"]=0
dizio["pos_op_f_y"]=0
dati = anydbm.open("dati_immagine","c")
dizio["scelta_strum"]=None
try:
    L = int(dati["DIL"])
    A = int(dati["DIA"])
    RS = int(dati["CFIR"])
    GS = int(dati["CFIG"])
    BS = int(dati["CFIB"])
    OIx = int(dati["OIx"])
    OIy = int(dati["OIy"])
    D = int(dati["D"])
    x = 2
    y = 200
    R=255
    G=255
    B=0
except:
    traceback.print_exc()
    #crea la struttura del database
    dati["DIL"]="400"; L = int(dati["DIL"])
    dati["DIA"]="400"; A = int(dati["DIA"])
    dati["CFIR"]="255"; RS = int(dati["CFIR"])
    dati["CFIG"]="255"; GS = int(dati["CFIG"])
    dati["CFIB"]="255"; BS = int(dati["CFIB"])
    dati["OIx"]="0"; OIx = int(dati["OIx"])
    dati["OIy"]="400"; OIy = int(dati["OIy"])
    dati["D"]="1"; D = int(dati["D"])
    x = 2
    y = 4
    R=0
    G=0
    B=0
    dati["EL1"]="RP2P"
    dati["EL1Px1"]="1"
    dati["EL1Px1"]="1"
    dati["EL1Px1"]="1"
    dati["EL1Px1"]="1"
    dati["EL2"]="CCR"

L,A,RS,GS,BS = 800,600,255,255,255
dizio["img"] = Image.new('RGB',(L,A),color=(RS,GS,BS))
#img = Image.new('RGB',(L,A),color=(RS,GS,BS))
root=Tkinter.Tk()
root.title("Bozze            (www.strutture-forme-colori-movimenti.net)")
dizio["Val_R"]=Tkinter.IntVar()
dizio["Val_R"].set(0)
#print dizio["Val_R"].get()
dizio["Val_G"]=Tkinter.IntVar()
dizio["Val_G"].set(0)
dizio["Val_B"]=Tkinter.IntVar()
dizio["Val_B"].set(0)
dizio["Val_spes"]=Tkinter.IntVar()
dizio["Val_spes"].set(0)
yT = Tkinter.StringVar()
yT.set(y)
dizio["pos_f_x"]= -500
dizio["pos_f_y"]= 250
dizio["pos_f_x_ass_x"]=Tkinter.IntVar()
dizio["pos_f_y_ass_x"]=Tkinter.IntVar()
dizio["pos_f_x_ass_y"]=Tkinter.IntVar()
dizio["pos_f_y_ass_y"]=Tkinter.IntVar()
dizio["pos_f_x_ass_z"]=Tkinter.IntVar()
dizio["pos_f_y_ass_z"]=Tkinter.IntVar()
dizio["pos_f_x_ass_x"].set(-500)
dizio["pos_f_y_ass_x"].set(250)
dizio["pos_f_x_ass_y"].set(1000)
dizio["pos_f_y_ass_y"].set(250)
dizio["pos_f_x_ass_z"].set(400)
dizio["pos_f_y_ass_z"].set(1800)
#print yT
spaz_1 = Tkinter.Frame(root)
spaz_1.pack(side = Tkinter.TOP,anchor=Tkinter.CENTER)
Tkinter.Button(spaz_1,text= "Disegna",command=disegna).pack(side=Tkinter.LEFT)
Tkinter.Button(spaz_1,text= "Cancella e disegna",command=ridisegna).pack(side=Tkinter.LEFT)
Tkinter.Button(spaz_1,text= "Cancella",command=cancella).pack(side=Tkinter.LEFT)
Tkinter.Button(spaz_1,text= "Termina",command=termina).pack(side=Tkinter.LEFT)
Tkinter.Button(spaz_1,text= "Colore",command=colore).pack(side=Tkinter.LEFT)
Tkinter.Entry(spaz_1,text= "Altezza",textvariable=yT).pack(side=Tkinter.LEFT)
Tkinter.Button(spaz_1,text= "Cosa tracciare",command=cosa_trac).pack(side=Tkinter.LEFT)
dizio["Pos_Mx"]=Tkinter.IntVar()
dizio["Pos_My"]=Tkinter.IntVar()
dizio["Pos_Mx"].set(0)
dizio["Pos_My"].set(0)
Tkinter.Entry(spaz_1,text= "Pos x",textvariable=dizio["Pos_Mx"]).pack(side=Tkinter.LEFT)
Tkinter.Entry(spaz_1,text= "Pos y",textvariable=dizio["Pos_My"]).pack(side=Tkinter.LEFT)
spaz_2 = Tkinter.Frame(root)
spaz_2.pack(side = Tkinter.TOP,fill=Tkinter.X)
dizio["fines"] = Tkinter.Canvas(spaz_2,width=L,height=A)
#list_met_canvas = dir(dizio["fines"])
#list_met_canvas.sort()
#for c in list_met_canvas:
#    print c
#print dir(dizio["fines"])
dizio["fines"].bind("<Button - 1>",mouse_B1p)
dizio["fines"].bind("<B1 -Motion>",pos_mouse_B1p)
dizio["fines"].bind("<ButtonRelease - 1>",mouse_B1r)
dizio["fines"].bind("<Motion>",pos_mouse)
root.bind("<KeyPress - x>",prem_car_x)
root.bind("<KeyPress - y>",prem_car_y)
root.bind("<KeyPress - z>",prem_car_z)
#dizio["immag"]=Tkinter.IntVar()
dizio["immag"] = ImageTk.PhotoImage(dizio["img"])
#immag = ImageTk.PhotoImage(img)
#dizio["immag"]=Tkinter.StringVar()
#dizio["immag"].set(ImageTk.PhotoImage(dizio["img"]))
dizio["idogg"] = dizio["fines"].create_image(0,0,image=dizio["immag"],anchor=Tkinter.NW)
#dizio["fines"].update()
#dizio["imma"] = imma
#dizio["fines"] = fines
#dizio["immag"] = immag
dizio["root"] = root
dizio["y"] = y
#dizio["img"] = img
dizio["fines"].pack()
root.mainloop()

#f3dizio["list_comp_prod"].focus_set()
#print root.focus_get()
#conversione da intero a esadecimale e viceversa
#intvar = 47
#hexvar = hex(intvar)
#print intvar, "   to hex = ", hexvar
#newintvar = int(hexvar, 16)
#print hexvar, " to int = ", newintvar

#file_da_salvare=tkFileDialog.asksaveasfilename(title='Esporta Disegno', filetypes=[ ('File PostScript!','*.ps')])
#canvas.postscript(file=file_da_salvare)

